fix regression in last commit, ommiting a frame
[errhandle.git] / err
diff --git a/err b/err
index 4a68f0a00981b157649e1ebf93b1af3cbac7d7d8..14253062d09bedcd6872b16d313e7a6850421fce 100644 (file)
--- a/err
+++ b/err
 # call manually (see the comments at the start of each one), and then
 # runs err-catch. See the README file for a slightly longer explanation.
 
+
+#######################################
+# Undoes err-catch. turns off exit and stack trace on error.
+#######################################
 err-allow() {
-  # help: turn off exit and stack trace on error. undoes err-catch
   set +E +o pipefail; trap ERR
 }
 
-err-bash-trace() {
-  # help: print stack trace
-  #
-  # Note: It does not show function args unless you first run:
-  # shopt -s extdebug
-  # err-catch runs this for you.
 
-  local -i argc_index=0 frame i start=${1:-1} max_indent=8 indent
+#######################################
+# Print stack trace
+#
+# usage: err-bash-trace [FRAME_START]
+#
+# It does not show function args unless you first run:
+# shopt -s extdebug
+# which err-catch & err-print does for you.
+#
+# FRAME_START   The frame to start printing on. default=0. Useful when
+#               printing from an ERR trap function to avoid printing
+#               that function.
+#######################################
+err-bash-trace() {
+  local -i argc_index=0 frame i start=${1:-0} max_indent=8 indent
   local source
   local extdebug=false
   if [[ $(shopt -p extdebug) == *-s* ]]; then
@@ -44,7 +55,7 @@ err-bash-trace() {
     if (( ${#BASH_SOURCE[@]} > 1 )); then
       source="${BASH_SOURCE[frame+1]}:${BASH_LINENO[frame]}:"
     fi
-    indent=$((frame-start+1))
+    indent=$((frame-start + 1))
     indent=$((indent < max_indent ? indent : max_indent))
     printf "%${indent}s↳%sin \`%s" '' "$source" "${FUNCNAME[frame]}"
     if $extdebug; then
@@ -54,22 +65,24 @@ err-bash-trace() {
     fi
     echo \'
   done
+  return 0
 }
 
+#######################################
+# On error print stack trace and exit
+#
+# Globals:
+#   ${_errcatch_cleanup[@]}  Optional command & args that will run before exiting
+#######################################
 err-catch() {
-  # help: on errors: print stack trace and exit
-  #
-  # You can set "${_errcatch_cleanup[@]}" to a command and it will run before exiting.
-  # This function depends on err-bash-trace.
-
   set -E; shopt -s extdebug
   _err-trap() {
     err=$?
     exec >&2
     set +x
-    echo "${BASH_SOURCE[1]}:${BASH_LINENO[0]}:in \`$BASH_COMMAND' returned $err"
-    # err trap does not work within an error trap, the following line:
-    err-bash-trace 2; set -e
+    echo "${BASH_SOURCE[1]}:${BASH_LINENO[0]}: \`$BASH_COMMAND' returned $err"
+    err-bash-trace 2
+    set -e # err trap does not work within an error trap
     "${_errcatch_cleanup[@]:-:}" # note :-: is to be compatible with set -u
     echo "$0: exiting with code $err"
     exit $err
@@ -78,25 +91,50 @@ err-catch() {
   set -o pipefail
 }
 
-err-exit() {
-  # usage: err-exit [EXIT_CODE] [MESSAGE]
-  # help: exit and print stack trace.
+#######################################
+# On error, print stack trace
+#######################################
+err-print() {
+  # help: on errors: print stack trace
   #
-  # Use this instead of the exit command to be more informative. default
-  # EXIT_CODE is 1. If only one of EXIT_CODE and MESSAGE is given,
-  # we consider it to be an exit code if it is a number.
   # This function depends on err-bash-trace.
 
+  set -E; shopt -s extdebug
+  _err-trap() {
+    err=$?
+    exec >&2
+    set +x
+    echo "${BASH_SOURCE[1]}:${BASH_LINENO[0]}: \`$BASH_COMMAND' returned $err"
+    err-bash-trace 2
+  }
+  trap _err-trap ERR
+  set -o pipefail
+}
+
+
+#######################################
+# On error, print stack trace
+#
+# Use this instead of the exit command to be more informative.
+#
+# usage: err-exit [EXIT_CODE] [MESSAGE]
+#
+# EXIT_CODE  Default is 1.
+# MESSAGE    Print MESSAGE to stderr. If only one of EXIT_CODE
+#            and MESSAGE is given, we consider it to be an
+#            exit code if it is a number.
+#######################################
+err-exit() {
   exec >&2
   code=1
   if [[ "$*" ]]; then
     if [[ ${1/[^0-9]/} == "$1" ]]; then
       code=$1
       if [[ $2 ]]; then
-        printf '%s\n' "$2"
+        printf '%s\n' "$2" >&2
       fi
     else
-      printf '%s\n' "$0: $1"
+      printf '%s\n' "$0: $1" >&2
     fi
   fi
   echo "${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
@@ -105,4 +143,5 @@ err-exit() {
   exit $err
 }
 
+# We want this more often than not, so run it now.
 err-catch